%define		rel		1
%define		gitver	07af971
Summary:	C library intended for use on embedded systems
Name:		crossnacl-newlib
Version:	2.0.0
Release:	0.git%{gitver}.%{rel}
License:	BSD and MIT and LGPL v2+
Group:		Libraries
Source0:	nacl-newlib-%{version}-git%{gitver}.tar.xz
# Source0-md5:	2e8b05e7ebe9eefa3e0d3f6d0ab23a1e
Source1:	nacl-headers-33.0.1750.117.tar.xz
# Source1-md5:	26f4e73044f01cbe0b89bec7fa4deea1
Source2:	newlib-libc-script
Source3:	pthread.h
Source4:	get-source.sh
URL:		http://sourceware.org/newlib/
BuildRequires:	crossnacl-binutils
BuildRequires:	crossnacl-gcc
BuildRequires:	fslint
BuildRequires:	python-modules
BuildRequires:	tar >= 1:1.22
BuildRequires:	xz
ExclusiveArch:	%{ix86} %{x8664}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		target		x86_64-nacl

%description
Newlib is a C library intended for use on embedded systems. It is a
conglomeration of several library parts, all under free software
licenses that make them easily usable on embedded products.

This is the NaCl fork.

%prep
%setup -q -n nacl-newlib-%{version}-git%{?gitver}
tar -xvf %{SOURCE1} -C newlib/libc/sys/nacl --strip-components=1
cp -p %{SOURCE2} .

%{__rm} etc/*.texi

%build
export NEWLIB_CFLAGS="-O2 -D_I386MACH_ALLOW_HW_INTERRUPTS -DSIGNAL_PROVIDED -mtls-use-call"
%configure \
	--disable-libgloss \
	--enable-newlib-iconv \
	--enable-newlib-io-long-long \
	--enable-newlib-io-long-double \
	--enable-newlib-io-c99-formats \
	--enable-newlib-mb \
	libc_cv_initfinit_array=yes \
	CFLAGS="-O2" \
	CFLAGS_FOR_TARGET="$NEWLIB_CFLAGS" \
	CXXFLAGS_FOR_TARGET="$NEWLIB_CFLAGS" \
	MAKEINFO=/bin/false \
	--target=%{target}

%{__make}

%install
rm -rf $RPM_BUILD_ROOT
%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

# Conflicts with binutils
%{__rm} -r $RPM_BUILD_ROOT%{_infodir}

# The default pthread.h doesn't work right?
%{__rm} $RPM_BUILD_ROOT%{_prefix}/%{target}/include/pthread.h
cp -p %{SOURCE3} $RPM_BUILD_ROOT%{_prefix}/%{target}/include

# We have to hack up libc.a to get things working.
# 32bit
mv $RPM_BUILD_ROOT%{_prefix}/%{target}/lib/32/libc.a $RPM_BUILD_ROOT%{_prefix}/%{target}/lib/32/libcrt_common.a
sed "s/@OBJFORMAT@/elf32-nacl/" newlib-libc-script > $RPM_BUILD_ROOT%{_prefix}/%{target}/lib/32/libc.a

# 64bit (default)
mv $RPM_BUILD_ROOT%{_prefix}/%{target}/lib/libc.a $RPM_BUILD_ROOT%{_prefix}/%{target}/lib/libcrt_common.a
sed "s/@OBJFORMAT@/elf64-nacl/" newlib-libc-script > $RPM_BUILD_ROOT%{_prefix}/%{target}/lib/libc.a

# move to match -m32 -lm search path gcc uses: /usr/x86_64-nacl/lib32/libm.a
install -d $RPM_BUILD_ROOT%{_prefix}/%{target}/lib32
mv $RPM_BUILD_ROOT%{_prefix}/%{target}/{lib/32/*,lib32}
rmdir $RPM_BUILD_ROOT%{_prefix}/%{target}/lib/32

# fix copies to be hardlinks (maybe should symlink in the future)
findup -m $RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%{_datadir}/iconv_data
%{_prefix}/%{target}/include
%{_prefix}/%{target}/lib
%dir %{_prefix}/%{target}/lib32
%{_prefix}/%{target}/lib32/lib*.a
%{_prefix}/%{target}/lib32/crt*.o
%changelog
* Thu Mar 06 2014 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/crossnacl-newlib.git;a=log;h=master

* Mon Feb 24 2014 Elan Ruusamäe <glen@delfi.ee> 170d78e
- up to 2.0.0 (git 07af971)

* Mon May 27 2013 Elan Ruusamäe <glen@delfi.ee> 63f0147
- BR: python-modules

* Sun May 26 2013 Elan Ruusamäe <glen@delfi.ee> dced36f
- up to git 5feee65

* Wed Mar 27 2013 Elan Ruusamäe <glen@delfi.ee> 7a5c776
- up nacl-headers to 26.0.1410.43

* Tue Feb 26 2013 Elan Ruusamäe <glen@delfi.ee> 7f7ce5f
- up to git 6a104f4 matching chromium 25.0.1364.97

* Tue Jan 01 2013 Elan Ruusamäe <glen@delfi.ee> 07585df
- use git archive to xz

* Fri Dec 07 2012 Elan Ruusamäe <glen@delfi.ee> 723e7f1
- update for omahaproxy changes

* Sun Nov 11 2012 Elan Ruusamäe <glen@delfi.ee> 6fc77ad
- move 32bit libs to match -m32 -lm search path gcc uses: /usr/x86_64-nacl/lib32/libm.a

* Sun Nov 11 2012 Elan Ruusamäe <glen@delfi.ee> d697411
- avoid building .info from .text, as we are removing the result files

* Sun Nov 11 2012 Elan Ruusamäe <glen@delfi.ee> b26932d
- up to 51a8366 (matching chromium 23.0.1271.64)

* Sun Nov 11 2012 Elan Ruusamäe <glen@delfi.ee> 0931a2e
- use http url for omahaproxy

* Sun Sep 30 2012 Elan Ruusamäe <glen@delfi.ee> f75c5be
- updated from 22.0.1229.79

* Thu Sep 13 2012 Elan Ruusamäe <glen@delfi.ee> 80fb32c
- use bare git repo

* Thu Sep 13 2012 Elan Ruusamäe <glen@delfi.ee> 462cb7b
- use xz source

* Thu Sep 13 2012 Elan Ruusamäe <glen@delfi.ee> dfcb00b
- allow override channel

* Thu Sep 13 2012 Elan Ruusamäe <glen@delfi.ee> faeb5e3
- check errors

* Wed Aug 01 2012 Elan Ruusamäe <glen@delfi.ee> 61543cf
- use nacl trunk var

* Wed Aug 01 2012 Elan Ruusamäe <glen@delfi.ee> 78a56c9
- up to git 67e3510, nacl-headers-21.0.1180.57

* Fri Jul 06 2012 Elan Ruusamäe <glen@pld-linux.org> ead93dd
- add nacl_trunk variable

* Fri Jul 06 2012 Elan Ruusamäe <glen@pld-linux.org> ad4b851
- update also newlib-libc-script and pthread.h

